unit MainF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, ExtCtrls, StdCtrls, Menus, {$IFNDEF VER100}ImgList, {$ENDIF}
  QLocal, QFormLocal, QLocalSource, Db, DBTables, QLocalDBSource;

type
  TfmMain = class(TForm)
    paTreeView: TPanel;
    sbSample: TStatusBar;
    tbSample: TToolBar;
    tvSample: TTreeView;
    paTreeViewCaption: TPanel;
    paClient: TPanel;
    paSampleControls: TPanel;
    spVertical: TSplitter;
    laSampleCombo: TLabel;
    cbSample: TComboBox;
    laSampleListBox: TLabel;
    lbSample: TListBox;
    rgSample: TRadioGroup;
    chSample1: TCheckBox;
    chSample2: TCheckBox;
    chSample3: TCheckBox;
    buSample1: TButton;
    buSample2: TButton;
    MainMenu: TMainMenu;
    miFile: TMenuItem;
    miExit: TMenuItem;
    miHelp: TMenuItem;
    miAbout: TMenuItem;
    pcSample: TPageControl;
    tsPage1: TTabSheet;
    tsPage2: TTabSheet;
    meSample: TMemo;
    stSample: TStaticText;
    miLanguage: TMenuItem;
    tbuLanguage: TToolButton;
    Images: TImageList;
    pmLanguages: TPopupMenu;
    tbuAbout: TToolButton;
    tsPage3: TTabSheet;
    lvSample: TListView;
    Localizer: TQFormLocalizer;
    LangSource: TQDBLanguageSource;
    tblLanguages: TTable;
    procedure miAboutClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pmLanguagesPopup(Sender: TObject);
    procedure LocalizerLanguageChanged(Sender: TObject);
    procedure LangSourceLanguageChanged(Sender: TObject);
  private
    procedure LanguageItemClick(Sender: TObject);
  end;

var
  fmMain: TfmMain;

implementation

uses AboutF, ShellApi;

resourcestring
  sAppTitle = 'EMS QuickLocalizer demo application';

{$R *.DFM}

procedure TfmMain.miAboutClick(Sender: TObject);
begin
  fmAbout := TfmAbout.Create(nil);
  try
    fmAbout.ShowModal();
  finally
    fmAbout.Free();
  end;
end;

procedure TfmMain.miExitClick(Sender: TObject);
begin
  Close();
end;

procedure TfmMain.FormCreate(Sender: TObject);
var
  I: integer;
  Item: TMenuItem;
begin
  Application.Title := sAppTitle;
  for I := -1 to fmMain.LangSource.Languages.Count - 1 do begin
    Item := TMenuItem.Create(Self);
    if I = -1
      then Item.Caption := fmMain.LangSource.OriginalName
      else Item.Caption := fmMain.LangSource.LanguageName[I];
    Item.Tag := I + 2;
    Item.RadioItem := True;
    Item.OnClick := LanguageItemClick;
    miLanguage.Insert(I + 1, Item);
    Item := TMenuItem.Create(Self);
    if I = -1
      then Item.Caption := fmMain.LangSource.OriginalName
      else Item.Caption := fmMain.LangSource.LanguageName[I];
    Item.Tag := I + 2;
    Item.RadioItem := True;
    Item.OnClick := LanguageItemClick;
    pmLanguages.Items.Insert(I + 1, Item);
  end;
  miLanguage.Items[fmMain.LangSource.ActiveLanguage + 1].Checked := True;
  pmLanguages.Items[fmMain.LangSource.ActiveLanguage + 1].Checked := True;
end;

procedure TfmMain.LanguageItemClick(Sender: TObject);
var
  I: integer;
begin
  if Sender is TMenuItem then begin
    TMenuItem(Sender).Checked := True;
    for I := 0 to miLanguage.Count - 1 do
      if miLanguage.Items[I].Tag = TMenuItem(Sender).Tag then begin
        miLanguage.Items[I].Checked := True;
        Break;
      end;
    for I := 0 to pmLanguages.Items.Count - 1 do
      if pmLanguages.Items[I].Tag = TMenuItem(Sender).Tag then begin
        pmLanguages.Items[I].Checked := True;
        Break;
      end;
    if (TMenuItem(Sender).Tag > 0) and
       (TMenuItem(Sender).Tag < fmMain.LangSource.Languages.Count + 2)
      then fmMain.LangSource.ActiveLanguage := TMenuItem(Sender).Tag - 2;
  end;
end;

procedure TfmMain.pmLanguagesPopup(Sender: TObject);
begin
  if fmMain.LangSource.Languages.Count < pmLanguages.Items.Count
    then pmLanguages.Items[fmMain.LangSource.ActiveLanguage + 1].Checked := True;
end;

procedure TfmMain.LocalizerLanguageChanged(Sender: TObject);
begin
  inherited;
  if cbSample.Items.Count > 0
    then cbSample.ItemIndex := 0;
end;

procedure TfmMain.LangSourceLanguageChanged(Sender: TObject);
begin
  if LangSource.ActiveLanguage < 0 then
    Application.Title := sAppTitle
  else begin
    LangSource.FormSection := 'Additional Strings';
    Application.Title := LangSource.LoadString('sAppTitle', sAppTitle);
  end;
end;

end.
